<template>
    <div v-if="value && value.length" class="extras">
        <template  v-for="(extra, index) in value" >
            <diff-table :key="index" mode="multiple" v-model="value[index]" :path="editParamsPath(index)"
                :id="`${editParamsPath(index).field}:${index}`" :diff-data="diffData[index]" :editMode="editMode"
                :editableParams="editableParams" @edited="editHandler" class="extras__item"/>
        </template>
    </div>
</template>

<script>
import DiffTable from '@/components/tables/DiffTable';

export default {
    components: {
        DiffTable,
    },
    props: {
        /** extra fields data */
        value: {
            type: Array,
            required: true,
        },
        /** pending and published variants of extra fields */
        diffData: {
            type: Array,
            required: false,
            default: () => [],
        },
        /** settings for edit mode */
        editableParams: {
            type: Object,
            required: false,
        },
        /** flag of activated edit mode */
        editMode: {
            type: Boolean,
            required: true,
        },
    },
    computed: {
        editParamsPath: () => index => ({ root: 'pending_profile', field: 'extra_fields', index }),
    },
    methods: {
        /**
         * Handler on editing any extra field
         * @param {Object} editData - edited parameter from the extra_fields section
         * */
        editHandler(editData) {
            this.$store.commit('updatePendingProfileParam', editData);
            this.$store.commit('updateEditedFields', editData);
        },
    },
};
</script>

<style lang="stylus" scoped>
.extras
    padding-top: 1rem

.extras__item
    margin: 3rem 0 1rem;

.extras__item:first-child
    margin-top: 1rem

</style>
